<?php

namespace xenarabia\LimitThreads\XF\Entity;


use XF\Mvc\ParameterBag;

class Forum extends XFCP_Forum{

    public function canCreateThread(&$error = null)
    {
        $visitor = \XF::visitor();
            $options = \XF::options();
            if($options->lu_act == 1)
            {
               if ( in_array($visitor->user_group_id,$options->lu_userg ) 
                    && in_array($this->node_id,$options->lu_forum ) 
                    && $this->generalQuery() >= $options->lu_thread ) 
                {
                    $error = \XF::phrase($options->lu_msg);

                    return false;
                } 
            }
        
           return parent::canCreateThread();
    }

    public function getUserThreadTotal()
    {
        $visitor = \XF::visitor();
        $options = \XF::options();
        if($options->lu_act == 1 )
        {
            if ( in_array($visitor->user_group_id,$options->lu_userg ) 
                && in_array($this->node_id,$options->lu_forum ) 
                &&  $options->lu_show_msg == 1
                && $this->generalQuery() >= $options->lu_thread ) 
            {
                return false;
            }else{
                return true;
            }
        }

        
    }

    private function generalQuery()
    {
        $repo = $this->repository('xenarabia\LimitThreads\XF:LmRepository');
        return $repo->getUserOpenThreads()
        ->total();
    }

}